import clojure.lang.LockingTransaction;

import java.util.concurrent.Callable;

public class AccountService {
  public static void transfer(
      final Account from, final Account to,
      final int amount) throws Exception {
    try {
      LockingTransaction.runInTransaction(new Callable<Void>() {
        public Void call() throws Exception {
          System.out.println("transfering... " + amount);
          to.deposit(amount);
          Thread.sleep(3000); //simulated delay to make transactions collide
          from.withdraw(amount);
          return null;
        }
      });
      System.out.println("transfer complete..." + amount);
    } catch(Exception ex) {
      System.out.println(ex.getMessage());
    }
  }
}