import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class Sample {
 public static void main(String[] args) throws Exception {
   final Account account1 = new Account(1000);
   final Account account2 = new Account(1000);

   //let's add a constraint, these two
   //accounts must have a combined balance
   //of at least $1500

   ExecutorService executorService = Executors.newFixedThreadPool(10);

   executorService.submit(new Runnable() {
     public void run() {
       try {
         AccountService.withdraw(account1,
             account2, 400);
       } catch (Exception e) {
         e.printStackTrace();
       }
     }
   });

   executorService.submit(new Runnable() {
     public void run() {
       try {
         AccountService.withdraw(account2,
             account1, 400);
       } catch (Exception e) {
         e.printStackTrace();
       }
     }
   });

   executorService.shutdown();

   Thread.sleep(10000);
   System.out.println(account1.getBalance());
   System.out.println(account2.getBalance());
 }
}
